diff -urN Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/Sender.java SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/Sender.java
--- Android_6.0.1_r11/frameworks/base/services/core/java/com/android/server/remote/Sender.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/services/core/java/com/android/server/remote/Sender.java	2017-09-22 03:20:53.485270000 +0900
@@ -0,0 +1,948 @@
+package com.android.server.remote;
+
+import java.io.BufferedInputStream;
+import java.io.ByteArrayOutputStream;
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.FileNotFoundException;
+import java.io.FileOutputStream;
+import java.io.IOException;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.io.OutputStream;
+import java.net.InetAddress;
+import java.net.Socket;
+import java.net.UnknownHostException;
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Random;
+import java.util.zip.Deflater;
+import java.util.zip.ZipEntry;
+import java.util.zip.ZipFile;
+
+import android.content.Context;
+import android.content.Intent;
+import android.graphics.Bitmap;
+import android.graphics.BitmapFactory;
+import android.graphics.Point;
+import android.location.Location;
+import android.os.AsyncTask;
+import android.os.Build;
+import android.os.Bundle;
+import android.provider.Settings;
+import android.provider.Settings.Secure;
+import android.service.devicemanagement.Device;
+import android.service.remote.AppendingObjectOutputStream;
+import android.service.remote.DexCode;
+import android.service.remote.RemoteRequest;
+import android.service.remote.ResourceAapt;
+import android.service.remote.SdPackage;
+import android.util.Log;
+import android.util.SparseArray;
+import android.view.Display;
+import android.view.MotionEvent;
+import android.view.WindowManager;
+
+import com.android.server.samd.SAMDService;
+
+//import com.google.common.io.ByteStreams;
+
+public class Sender {
+
+	private static final String TAG = "RemoteService_Sender";
+	private static final int SERVERPORT = 55555;
+
+	private int Xdefault;
+	private int Ydefault;
+
+	/*private ArrayList<String> connectedDevices = RemoteService.connectedDevices;
+	private HashMap<String, Socket> deviceToSocket = RemoteService.deviceToSocket;
+	private HashMap<String, AppendingObjectOutputStream> deviceToOutput = RemoteService.deviceToOutput;
+    private SparseArray<ArrayList<AppendingObjectOutputStream>> resourceToOutput = RemoteService.resourceToOutput;*/
+
+	private Thread connectionThread;
+
+	//SAMD
+	private Sender_ mSender;
+	private final Context mContext;
+	private String myName;
+
+	public Sender(Context context) {
+		mContext = context;
+		WindowManager wm = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
+		Display display = wm.getDefaultDisplay();
+		Point size = new Point();
+		display.getSize(size);
+
+		Xdefault = size.x;
+		Ydefault = size.y;
+
+		//myName = capitalize(Secure.getString(context.getContentResolver(),
+		//            Secure.ANDROID_ID));
+
+		myName = capitalize(Build.SERIAL);
+	}
+
+	// for resource request
+	public boolean connectToRemoteDevice(Device device) {
+		mSender = new Sender_(myName, device.ipaddress, device.askedResources);
+		connectionThread = new Thread(mSender);
+		connectionThread.start();
+
+		return true;
+	}
+
+	// for communication
+	public boolean connectToRemoteDevice(String deviceIP) {
+		mSender = new Sender_(myName, deviceIP);
+		connectionThread = new Thread(mSender);
+		connectionThread.start();
+
+
+		return true;
+	}
+
+	public boolean connectToRemoteDevices(List<Device> devices) {
+		for (Device device : devices)
+			connectToRemoteDevice(device);
+
+		return true;
+	}
+
+	public boolean disconnectAllDevices() {
+		try {
+			for (String device : RemoteService.connectedDevices) {
+				RemoteService.deviceToSocket.get(device).close();
+				RemoteService.deviceToOutput.get(device).close();
+
+				RemoteService.deviceToSocketforData.get(device).close();
+				RemoteService.deviceToOutputforData.get(device).close();
+			}
+			RemoteService.deviceToSocket.clear();
+			RemoteService.deviceToOutput.clear();
+			RemoteService.deviceToSocketforData.clear();
+			RemoteService.deviceToOutputforData.clear();
+		} catch (IOException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+
+		return true;
+	}
+
+	public boolean addRemoteDevice(ArrayList<Integer> resourceTypes, String deviceIP) {
+		if (!RemoteService.deviceToSocket.containsKey(deviceIP)) {
+			connectToRemoteDevice(deviceIP);
+			try {
+				connectionThread.join();
+			} catch (InterruptedException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+
+		for (int resourceType : resourceTypes) {
+			if (RemoteService.deviceToOutput.get(deviceIP) != null)
+				RemoteService.resourceToOutput.get(resourceType).add(RemoteService.deviceToOutput.get(deviceIP));
+			else
+				Log.d(TAG, resourceType + " is NULL!!!!!!!!");
+
+
+		}
+
+		return true;
+	}
+
+	public boolean addRemoteDevice(int[] resourceTypes, String deviceIP) {
+		Log.d("sbjsbjsbjsbjsbj","sbjsbjsbjsbjsbj addRemoteDevice");
+		if (!RemoteService.deviceToSocket.containsKey(deviceIP)) {
+			connectToRemoteDevice(deviceIP);
+			try {
+				connectionThread.join();
+			} catch (InterruptedException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+		//SAMD
+		if (!RemoteService.deviceToSocketforData.containsKey(deviceIP)) {
+			connectToRemoteDevice(deviceIP);
+			try {
+				connectionThread.join();
+			} catch (InterruptedException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+
+		for (int resourceType : resourceTypes) {
+			if (RemoteService.deviceToOutput.get(deviceIP) != null)
+				RemoteService.resourceToOutput.get(resourceType).add(RemoteService.deviceToOutput.get(deviceIP));
+			else
+				Log.d(TAG, resourceType + " is NULL!!!!!!!!");
+
+			//SAMD
+			if(RemoteService.deviceToOutputforData.get(deviceIP) != null){
+				RemoteService.resourceToOutputforData.get(resourceType).add(RemoteService.deviceToOutputforData.get(deviceIP));
+			}
+			if(RemoteService.deviceToInputforData.get(deviceIP) != null){
+				RemoteService.resourceToInputforData.get(resourceType).add(RemoteService.deviceToInputforData.get(deviceIP));
+			}
+			if(RemoteService.deviceToInput.get(deviceIP) != null){
+				RemoteService.resourceToInput.get(resourceType).add(RemoteService.deviceToInput.get(deviceIP));
+			}
+
+		}
+
+		return true;
+	}
+
+	public boolean respondAllowedResources(String deviceIP, int[] resources) {
+		if (RemoteService.deviceToOutput.get(deviceIP) != null) {
+			try {
+				AppendingObjectOutputStream output = RemoteService.deviceToOutput.get(deviceIP);
+				output.writeObject(resources);
+			} catch (IOException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+			return true;
+		}
+
+		return false;
+	}
+
+	public boolean sendRequestToEveryDevices(RemoteRequest request) {
+		try {
+			for (String deviceIP : RemoteService.connectedDevices)
+				RemoteService.deviceToOutput.get(deviceIP).writeObject(request);
+
+		} catch (IOException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		return true;
+	}
+
+	public void sendMotionEvent(MotionEvent event) {
+		//Log.d(TAG, "1: " + event.toString());
+
+		float x = event.getX();
+		float y = event.getY();
+
+		RemoteMotionEvent rme = new RemoteMotionEvent(event.getDownTime(),
+				event.getEventTime(), x / Xdefault, y / Ydefault,
+				event.getAction(), event.getSource());
+
+
+		try {
+			//Log.d(TAG, "2: " + RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_TOUCH).size());
+
+			for (AppendingObjectOutputStream output : RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_TOUCH)) {
+				if (output == null)
+					Log.d(TAG, "NULL!!!!!!!!");
+				else
+					output.writeObject(rme);
+			}
+		} catch (IOException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+
+	public void sendSensorEvent(RemoteSensorEvent rse) {
+		try {
+			//Log.d(TAG, rse.toString());
+
+			for (AppendingObjectOutputStream output : RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_SENSOR))
+				output.writeObject(rse);
+		} catch (IOException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+
+	public void sendLocation(Location location) {
+		// TODO Auto-generated method stub
+		RemoteLocation RL = new RemoteLocation(location);
+
+		try {
+			for (AppendingObjectOutputStream output : RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_LOCATION))
+				output.writeObject(RL);
+		} catch (IOException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+
+	public void sendMusicData(SdPackage MDtoSend) {
+		try {
+			for (AppendingObjectOutputStream output : RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_AUDIO))
+				output.writeObject(MDtoSend);
+		} catch (IOException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	public void sendVideoSignal(int vport) {
+		Log.d(TAG, "VideoSignal: " + vport);
+
+		RemoteRequest request = new RemoteRequest();
+		ArrayList<Object> vInfo = new ArrayList<Object>();
+		vInfo.add(0, vport);
+		vInfo.add(1, vport);
+		request.set("video_streaming", "get_surface", vInfo);
+
+		for (AppendingObjectOutputStream output : RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_VIDEO)) {
+			if (output == null) {
+				Log.d(TAG, "NULL!!!!!!");
+			} else {
+				try {
+					output.writeObject(request);
+				} catch (IOException e) {
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				}
+			}
+			vport = vport + 2;
+			vInfo.set(1, vport);
+		}
+	}
+	private String capitalize(String s) {
+		if (s == null || s.length() == 0) {
+			return "";
+		}
+		char first = s.charAt(0);
+		if (Character.isUpperCase(first)) {
+			return s;
+		} else {
+			return Character.toUpperCase(first) + s.substring(1);
+		}
+	}
+	public boolean initializeAR(int deviceNum, String appName){
+		boolean result = false;
+		if(appName != null){
+			Log.d("uuuuuuu_initializeAR",
+					"s-----------------------------------------------------------------------------------------------");
+			SAMDService.CURRENT_APP_NAME = appName;
+
+			ArrayList<Object> zipInfo = new ArrayList<Object>();
+			zipInfo.add(0, appName);
+
+			RemoteRequest request = new RemoteRequest();
+			request.set("initializeAR", "init", zipInfo);
+			ArrayList<AppendingObjectOutputStream> output_list = RemoteService.resourceToOutput
+					.get(Device.RESOURCE_TYPE_REMOTE_ACTIVITY);
+			ArrayList<ObjectInputStream> input_list = RemoteService.resourceToInput
+					.get(Device.RESOURCE_TYPE_REMOTE_ACTIVITY);
+			AppendingObjectOutputStream output = output_list.get(deviceNum);
+			ObjectInputStream input = input_list.get(deviceNum);
+			if (output == null) {
+				Log.d(TAG, "NULL!!!!!!");
+			} else {
+				try {
+					output.writeObject(request);
+					output.flush();
+				} catch (IOException e) {
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				}
+			}
+			try{
+				String responseFromClient = input.readObject().toString();
+				if(responseFromClient.equals("init ok")){
+					Log.d("uuuuuuu_initializeAR","receive from client : " + responseFromClient);
+					result = true;
+
+				}
+			}catch(Exception e){
+				e.printStackTrace();
+			}
+
+			Log.d("uuuuuuu_initializeAR",
+					"e-----------------------------------------------------------------------------------------------");
+		}
+		return result;
+	}
+	public boolean sendDexActivity(int deviceNumber, String DexFile, List<String> resourceFiles){
+
+		Log.d("uuuuuuu_sendDexActivity",
+				"s-----------------------------------------------------------------------------------------------");
+		//17.03.02
+		//dex files transfer
+		FileInputStream fileInputStream = null;
+		ByteArrayOutputStream bos = null;
+		ArrayList<Object> zipInfo = new ArrayList<Object>();
+		boolean turn = true;
+		try {
+			//dexes
+			zipInfo.add(0, deviceNumber+1);
+			Log.d("uuuuuuu_sendDexActivity", "dexFiles : " + DexFile);
+			File dexFile = new File("/collaboroid/preprocess/" + SAMDService.CURRENT_APP_NAME + "/dex/" + DexFile + "_classes.dex");
+
+			fileInputStream = new FileInputStream(dexFile);
+			bos = new ByteArrayOutputStream();
+			byte[] buf = new byte[4096];
+			for (int readNum; (readNum = fileInputStream.read(buf)) != -1; ) {
+				bos.write(buf, 0, readNum);
+			}
+			byte[] classesByte = bos.toByteArray();
+
+			zipInfo.add(1, DexFile);
+			zipInfo.add(2, classesByte);
+			//resources
+			if(resourceFiles.size()!=0){
+
+				List<String> preResourceFiles = new ArrayList<String>();
+				for(int i=0; i<resourceFiles.size(); i++){
+					if(resourceFiles.get(i).contains("!")){
+						preResourceFiles.add(resourceFiles.get(i).split("!")[1]);
+						resourceFiles.remove(i);
+						i--;
+					}
+				}
+				try {
+					//Pre Sended
+					zipInfo.add(3, preResourceFiles.size());
+					int preResourceNum = preResourceFiles.size();
+					Log.d("uuuuuuu_sendResourcesLR", "send preResourceNum : " + preResourceNum);
+					for(int i=0, j=4; i<preResourceNum; i++, j++){
+						zipInfo.add(j, preResourceFiles.get(i));
+						Log.d("uuuuuuu_sendResourcesLR", "j : "+j+"/ preresource zipInfo.add : " + preResourceFiles.get(i));
+					}
+					//Now Sended
+					zipInfo.add(4+preResourceNum, resourceFiles.size());
+					Log.d("uuuuuuu_sendResourcesLR", "send resourceFilesNum : " + resourceFiles.size());
+					for (int i=0, j=5+preResourceNum; i<resourceFiles.size(); i++,j+=2) {
+						File resourceFile = new File("/collaboroid/preprocess/"
+								+ SAMDService.CURRENT_APP_NAME +
+								"/" +
+								resourceFiles.get(i).replace(resourceFiles.get(i).split("\\/")[0]+"/",""));
+
+						if(resourceFile.isFile()){
+							fileInputStream = new FileInputStream(resourceFile);
+
+							bos = new ByteArrayOutputStream();
+							Log.d("fileData","fileData start : " + resourceFile.toString());
+							for (int readNum; (readNum = fileInputStream.read(buf, 0, buf.length)) != -1; ) {
+								bos.write(buf, 0, readNum);
+							}
+							//Dynamic3r3 a1.png, a2.png  = delay 0.2sec
+							Log.d("fileData","fileData end : " + resourceFile.toString());
+							classesByte = bos.toByteArray();
+							Log.d("fileData","fileData classByte : " + classesByte.length);
+
+							bos.flush();
+							bos.reset();
+							bos = null;
+
+							zipInfo.add(j, resourceFiles.get(i));
+							zipInfo.add(j+1, classesByte);
+
+						}else{
+							resourceFiles.remove(i);
+							i-=1;
+							j-=2;
+						}
+					}
+					zipInfo.set(4+preResourceNum, resourceFiles.size());
+					ArrayList<AppendingObjectOutputStream> output_list = RemoteService.resourceToOutputforData
+							.get(Device.RESOURCE_TYPE_REMOTE_ACTIVITY);
+					ResourceAapt resourceAapt = new ResourceAapt();
+					resourceAapt.set("sendActivity", "withResource", zipInfo);
+					AppendingObjectOutputStream output = output_list.get(deviceNumber);
+					if (output == null) {
+						Log.d(TAG, "NULL!!!!!!!!");
+					} else {
+						output.writeObject(resourceAapt);
+						output.flush();
+					}
+				} catch (Exception e) {
+					e.printStackTrace();
+				}
+			}
+			if(bos != null){
+				bos.close();
+			}
+			if(fileInputStream != null){
+				fileInputStream.close();
+			}
+
+		} catch (IOException e) {
+			e.printStackTrace();
+		}
+		Log.d("uuuuuuu_sendDexActivity",
+				"e-----------------------------------------------------------------------------------------------");
+		return true;
+	}
+	public boolean sendDex(int deviceNumber, String DexFile, List<String> resourceFiles) {
+		Log.d("uuuuuuu_sendDex",
+				"s-----------------------------------------------------------------------------------------------");
+		//17.03.02
+		//dex files transfer
+		FileInputStream fileInputStream = null;
+		ByteArrayOutputStream bos = null;
+		ArrayList<Object> zipInfo = new ArrayList<Object>();
+		boolean turn = true;
+		try {
+			//dexes
+			zipInfo.add(0, deviceNumber+1);
+			Log.d("uuuuuuu_sendDex", "dexFiles : " + DexFile);
+			File dexFile = new File("/collaboroid/preprocess/" + SAMDService.CURRENT_APP_NAME + "/dex/" + DexFile + "_classes.dex");
+
+			fileInputStream = new FileInputStream(dexFile);
+			bos = new ByteArrayOutputStream();
+			byte[] buf = new byte[4096];
+			for (int readNum; (readNum = fileInputStream.read(buf)) != -1; ) {
+				bos.write(buf, 0, readNum);
+			}
+			byte[] classesByte = bos.toByteArray();
+
+			zipInfo.add(1, DexFile);
+			zipInfo.add(2, classesByte);
+			//resources
+			if(resourceFiles.size()!=0){
+
+				List<String> preResourceFiles = new ArrayList<String>();
+				for(int i=0; i<resourceFiles.size(); i++){
+					if(resourceFiles.get(i).contains("!")){
+						preResourceFiles.add(resourceFiles.get(i).split("!")[1]);
+						resourceFiles.remove(i);
+						i--;
+					}
+				}
+				try {
+					//Pre Sended
+					zipInfo.add(3, preResourceFiles.size());
+					int preResourceNum = preResourceFiles.size();
+					Log.d("uuuuuuu_sendResourcesLR", "send preResourceNum : " + preResourceNum);
+					for(int i=0, j=4; i<preResourceNum; i++, j++){
+						zipInfo.add(j, preResourceFiles.get(i));
+						Log.d("uuuuuuu_sendResourcesLR", "j : "+j+"/ preresource zipInfo.add : " + preResourceFiles.get(i));
+					}
+
+					//Now Sended
+					zipInfo.add(4+preResourceNum, resourceFiles.size());
+					Log.d("uuuuuuu_sendResourcesLR", "send resourceFilesNum : " + resourceFiles.size());
+					for (int i=0, j=5+preResourceNum; i<resourceFiles.size(); i++,j+=2) {
+						File resourceFile = new File("/collaboroid/preprocess/"
+								+ SAMDService.CURRENT_APP_NAME +
+								"/" +
+								resourceFiles.get(i).replace(resourceFiles.get(i).split("\\/")[0]+"/",""));
+
+						if(resourceFile.isFile()){
+							fileInputStream = new FileInputStream(resourceFile);
+
+							bos = new ByteArrayOutputStream();
+							Log.d("fileData","fileData start : " + resourceFile.toString());
+							for (int readNum; (readNum = fileInputStream.read(buf, 0, buf.length)) != -1; ) {
+								bos.write(buf, 0, readNum);
+							}
+							//Dynamic3r3 a1.png, a2.png  = delay 0.2sec
+							Log.d("fileData","fileData end : " + resourceFile.toString());
+							classesByte = bos.toByteArray();
+							Log.d("fileData","fileData classByte : " + classesByte.length);
+
+							bos.flush();
+							bos.reset();
+							bos = null;
+
+							zipInfo.add(j, resourceFiles.get(i));
+							zipInfo.add(j+1, classesByte);
+
+						}else{
+							resourceFiles.remove(i);
+							i-=1;
+							j-=2;
+						}
+					}
+					zipInfo.set(4+preResourceNum, resourceFiles.size());
+
+					ArrayList<AppendingObjectOutputStream> output_list = RemoteService.resourceToOutputforData
+							.get(Device.RESOURCE_TYPE_REMOTE_ACTIVITY);
+
+					DexCode dexCode = new DexCode();
+					dexCode.set("multiDexTransfer", "getMultiDex", zipInfo);
+					AppendingObjectOutputStream output = output_list.get(deviceNumber);
+					if (output == null) {
+						Log.d(TAG, "NULL!!!!!!!!");
+					} else {
+						Log.d("samd sub experiment", "File write objects start");
+						output.writeObject(dexCode);
+						output.flush();
+						Log.d("samd sub experiment", "File write objects end");
+					}
+				} catch (Exception e) {
+					e.printStackTrace();
+				}
+			}
+			if(bos != null){
+				bos.close();
+			}
+			if(fileInputStream != null){
+				fileInputStream.close();
+			}
+		} catch (IOException e) {
+			e.printStackTrace();
+		}
+		Log.d("uuuuuuu_sendDex",
+				"e-----------------------------------------------------------------------------------------------");
+		return true;
+	}
+	public void sendResourcesRL(List<String> resourceFiles, String appName) {
+
+		Log.d("sendResourcesRL",
+				"s-----------------------------------------------------------------------------------------------");
+		FileInputStream fileInputStream = null;
+		ByteArrayOutputStream bos = null;
+		ArrayList<Object> zipInfo = new ArrayList<Object>();
+		if(resourceFiles.size()!=0){
+			try {
+				zipInfo.add(0, SAMDService.remote_device_number);
+				zipInfo.add(1, appName);
+				zipInfo.add(2, resourceFiles.size());
+
+				for (int i=0, j=3; i<resourceFiles.size(); i++,j+=2) {
+					File dexFiles = new File("/data/collaboroid/preprocess/" + appName + "/" + resourceFiles.get(i));
+					Log.d("samd experiment", "appName : " + appName);
+					Log.d("samd experiment", "resource : " + resourceFiles.get(i));
+					if(dexFiles.isFile()){
+						fileInputStream = new FileInputStream(dexFiles);
+						bos = new ByteArrayOutputStream();
+						byte[] buf = new byte[4096];
+						for (int readNum; (readNum = fileInputStream.read(buf)) != -1; ) {
+							bos.write(buf, 0, readNum);
+						}
+						byte[] classesByte = bos.toByteArray();
+						zipInfo.add(j, resourceFiles.get(i));
+						zipInfo.add(j+1, classesByte);
+					}else{
+						resourceFiles.remove(i);
+						i-=1;
+						j-=2;
+					}
+				}
+				zipInfo.set(2, resourceFiles.size());
+
+				Log.d("sendResourcesRL", "resource size : " + resourceFiles.size());
+
+				for(int i=0; i<resourceFiles.size(); i++){
+					Log.d("sendResourcesRL", "resourceFiles : " + resourceFiles.get(i));
+				}
+
+				if(bos != null){
+					bos.close();
+				}
+				if(fileInputStream != null){
+					fileInputStream.close();
+				}
+
+				if(resourceFiles.size() > 0){
+					for (AppendingObjectOutputStream output : RemoteService.deviceToOutput.values()) {
+						RemoteRequest request = new RemoteRequest();
+						request.set("ResourcesTransfer", "getResourcesRL", zipInfo);
+						if (output == null) {
+							Log.d(TAG, "NULL!!!!!!!!");
+						} else {
+							output.writeObject(request);
+							output.flush();
+						}
+					}
+				}
+			} catch (IOException e) {
+				e.printStackTrace();
+			}
+		}
+		Log.d("sendResourcesRL",
+				"e-----------------------------------------------------------------------------------------------");
+	}
+
+	public void sendResourcesLR(int deviceNumber, List<String> resourceFiles) {
+		Log.d("uuuuuuu_sendResourcesLR",
+				"s-----------------------------------------------------------------------------------------------");
+		FileInputStream fileInputStream = null;
+		ByteArrayOutputStream bos = null;
+		ArrayList<Object> zipInfo = new ArrayList<Object>();
+		if(resourceFiles.size()!=0){
+			try {
+				zipInfo.add(0, resourceFiles.size());
+				for (int i=0, j=1; i<resourceFiles.size(); i++,j+=2) {
+					File dexFiles = new File("/data/collaboroid/preprocess/" + SAMDService.CURRENT_APP_NAME + "/" + resourceFiles.get(i));
+					if(dexFiles.isFile()){
+						fileInputStream = new FileInputStream(dexFiles);
+						bos = new ByteArrayOutputStream();
+						byte[] buf = new byte[4096];
+						for (int readNum; (readNum = fileInputStream.read(buf)) != -1; ) {
+							bos.write(buf, 0, readNum);
+						}
+						byte[] classesByte = bos.toByteArray();
+
+						zipInfo.add(j, resourceFiles.get(i));
+						zipInfo.add(j+1, classesByte);
+
+					}else{
+						resourceFiles.remove(i);
+						i-=1;
+						j-=2;
+					}
+				}
+				zipInfo.set(0, resourceFiles.size());
+				if(bos != null){
+					bos.flush();
+					bos.close();
+				}
+				if(fileInputStream != null){
+					fileInputStream.close();
+				}
+				Log.d("sendResourcesLR", "resource size : " + resourceFiles.size());
+				for(int i=0; i<resourceFiles.size(); i++){
+					Log.d("uuuuuuu_sendResourcesLR", "send resourceFiles : " + resourceFiles.get(i));
+				}
+				if(resourceFiles.size() > 0){
+					ArrayList<AppendingObjectOutputStream> output_list = RemoteService.resourceToOutputforData
+							.get(Device.RESOURCE_TYPE_REMOTE_ACTIVITY);
+
+					ArrayList<ObjectInputStream> input_list = RemoteService.resourceToInputforData
+							.get(Device.RESOURCE_TYPE_REMOTE_ACTIVITY);
+					ResourceAapt resource = new ResourceAapt();
+
+					resource.set("ResourcesTransfer", "getResourcesLR", zipInfo);
+					AppendingObjectOutputStream output = output_list.get(deviceNumber);
+					ObjectInputStream input = input_list.get(deviceNumber);
+
+					if (output == null) {
+						Log.d(TAG, "NULL!!!!!!!!");
+					} else {
+						output.writeObject(resource);
+						output.flush();
+					}
+
+				}
+			} catch (Exception e) {
+				e.printStackTrace();
+			}
+		}
+		Log.d("uuuuuuu_sendResourcesLR",
+				"e-----------------------------------------------------------------------------------------------");
+	}
+	public void sendActivity(int deviceNumber, String toSendActivityName) {
+		Log.d("uuuuuuu_sendActivity",
+				"s-----------------------------------------------------------------------------------------------");
+		try {
+			Log.d("uuuuuuu_sendActivity", toSendActivityName + " is Send!!!!");
+			ArrayList<Object> zipInfo = new ArrayList<Object>();
+			zipInfo.add(0, toSendActivityName);
+			RemoteRequest request = new RemoteRequest();
+			request.set("sendActivity", "OnlyName", zipInfo);
+			ArrayList<AppendingObjectOutputStream> output_list = RemoteService.resourceToOutput
+					.get(Device.RESOURCE_TYPE_REMOTE_ACTIVITY);
+			AppendingObjectOutputStream output = output_list.get(deviceNumber);
+			if (output == null) {
+				Log.d(TAG, "NULL!!!!!!!!");
+			} else {
+				output.writeObject(request);
+				output.flush();
+			}
+		} catch (IOException e) {
+			e.printStackTrace();
+		}
+		Log.d("uuuuuuu_sendActivity",
+				"e-----------------------------------------------------------------------------------------------");
+	}
+	public boolean sendActivityWithRes(int deviceNumber, String toSendActivityName, List<String> resourceFiles) {
+
+		// index 0 = toSendActivityName
+		// index 1 = pre Resources Size
+		// index 1+Size+1 = Resourcecs Size
+		Log.d("uuuuuuu_sendActivityWithRes",
+				"s-----------------------------------------------------------------------------------------------");
+		FileInputStream fileInputStream = null;
+		ByteArrayOutputStream bos = null;
+		ArrayList<Object> zipInfo = new ArrayList<Object>();
+		try {
+			//dexes
+			zipInfo.add(0, toSendActivityName);
+			//resources
+			if(resourceFiles.size()!=0){
+				List<String> preResourceFiles = new ArrayList<String>();
+				for(int i=0; i<resourceFiles.size(); i++){
+					if(resourceFiles.get(i).contains("!")){
+						preResourceFiles.add(resourceFiles.get(i).split("!")[1]);
+						resourceFiles.remove(i);
+						i--;
+					}
+				}
+				try {
+					//Pre Sended
+					zipInfo.add(1, preResourceFiles.size());
+					int preResourceNum = preResourceFiles.size();
+					Log.d("uuuuuuu_sendActivityWithRes", "send preResourceNum : " + preResourceNum);
+					for(int i=0, j=2; i<preResourceNum; i++, j++){
+						zipInfo.add(j, preResourceFiles.get(i));
+						Log.d("uuuuuuu_sendActivityWithRes", "j : "+j+"/ preresource zipInfo.add : " + preResourceFiles.get(i));
+					}
+					//Now Sended
+					zipInfo.add(2+preResourceNum, resourceFiles.size());
+					Log.d("uuuuuuu_sendActivityWithRes", "send resourceFilesNum : " + resourceFiles.size());
+					for (int i=0, j=3+preResourceNum; i<resourceFiles.size(); i++,j+=2) {
+						File resourceFile = new File("/collaboroid/preprocess/"
+								+ SAMDService.CURRENT_APP_NAME +
+								"/" +
+								resourceFiles.get(i).replace(resourceFiles.get(i).split("\\/")[0]+"/",""));
+						if(resourceFile.isFile()){
+							fileInputStream = new FileInputStream(resourceFile);
+							bos = new ByteArrayOutputStream();
+							byte[] buf = new byte[4096];
+							for (int readNum; (readNum = fileInputStream.read(buf)) != -1; ) {
+								bos.write(buf, 0, readNum);
+							}
+							byte[] classesByte = bos.toByteArray();
+							Log.d("uuuuuuu_sendActivityWithRes","j : "+j+"/ resource zipInfo.add  : " + resourceFiles.get(i));
+							Log.d("uuuuuuu_sendActivityWithRes","j : "+j+"/ resource zipInfo.add for dir : "
+									+ resourceFiles.get(i).replace(resourceFiles.get(i).split("\\/")[0]+"/",""));
+							zipInfo.add(j, resourceFiles.get(i));
+							zipInfo.add(j+1, classesByte);
+						}else{
+							resourceFiles.remove(i);
+							i-=1;
+							j-=2;
+						}
+					}
+					zipInfo.set(2+preResourceNum, resourceFiles.size());
+
+					ArrayList<AppendingObjectOutputStream> output_list = RemoteService.resourceToOutput
+							.get(Device.RESOURCE_TYPE_REMOTE_ACTIVITY);
+					RemoteRequest request = new RemoteRequest();
+					request.set("sendActivity", "WithResource", zipInfo);
+					AppendingObjectOutputStream output = output_list.get(deviceNumber);
+					if (output == null) {
+						Log.d(TAG, "NULL!!!!!!!!");
+					} else {
+						output.writeObject(request);
+						output.flush();
+					}
+				} catch (Exception e) {
+					e.printStackTrace();
+				}
+			}
+			if(bos != null){
+				bos.flush();
+				bos.close();
+			}
+			if(fileInputStream != null){
+				fileInputStream.close();
+			}
+
+		} catch (IOException e) {
+			e.printStackTrace();
+		}
+		Log.d("uuuuuuu_sendActivityWithRes",
+				"e-----------------------------------------------------------------------------------------------");
+		return true;
+	}
+	public void sendMessageLRD(int deviceNum, String msg) {
+		ArrayList<Object> zipInfo = new ArrayList<Object>();
+		zipInfo.add(0, 0);
+		zipInfo.add(1, msg);
+		RemoteRequest request = new RemoteRequest();
+		request.set("sendMessage", "getMessageLR", zipInfo);
+
+		ArrayList<AppendingObjectOutputStream> output_list = RemoteService.resourceToOutput
+				.get(Device.RESOURCE_TYPE_REMOTE_ACTIVITY);
+
+		AppendingObjectOutputStream output = output_list.get(deviceNum);
+
+
+		if (output == null) {
+			Log.d(TAG, "NULL!!!!!!");
+		} else {
+			try {
+				output.writeObject(request);
+				output.flush();
+			} catch (IOException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+
+	}
+
+	public void sendMessageRL(String msg) {
+		ArrayList<Object> zipInfo = new ArrayList<Object>();
+		zipInfo.add(0,SAMDService.remote_device_number);
+		zipInfo.add(1, msg);
+		zipInfo.add(2, System.currentTimeMillis());
+		RemoteRequest request = new RemoteRequest();
+		request.set("sendMessage", "getMessageRL", zipInfo);
+
+		for (AppendingObjectOutputStream output : RemoteService.deviceToOutput.values()) {
+			if (output == null) {
+				Log.d(TAG, "NULL!!!!!!!!");
+			} else {
+				try {
+					output.writeObject(request);
+					output.flush();
+				}catch (IOException e){
+					e.printStackTrace();
+				}
+			}
+		}
+	}
+
+
+	public void sendAPKFile(int deviceNum, String dir){
+		File APKfile = new File(dir);
+
+		FileInputStream fileInputStream = null;
+		ByteArrayOutputStream bos = null;
+		byte[] classesByte = null;
+		byte[] sbj_byte = null;
+		byte[] sbj_bb = null;
+
+		try {
+			Log.d("samd experiment", "File read data start " + deviceNum);
+			fileInputStream = new FileInputStream(APKfile);
+
+			sbj_bb = new byte[(int)APKfile.length()];
+			fileInputStream.read(sbj_bb);
+
+
+
+//			Log.d("samd sub experiment", "File read data start");
+//			bos = new ByteArrayOutputStream();
+//			byte[] buf = new byte[4096];
+//			for (int readNum; (readNum = fileInputStream.read(buf)) != -1; ) {
+//				bos.write(buf, 0, readNum);
+//			}
+//			classesByte = bos.toByteArray();
+
+			//sbj_byte = ByteStreams.toByteArray(fileInputStream);
+//			Log.d("samd experiment", "ByteStreams read data end");
+
+		} catch (Exception e) {
+			e.printStackTrace();
+		}
+		Log.d("samd sub experiment", "File read data end "  + deviceNum);
+
+
+
+		ArrayList<Object> zipInfo = new ArrayList<Object>();
+		//zipInfo.add(0, classesByte);
+		//zipInfo.add(0, sbj_byte);
+		zipInfo.add(0, sbj_bb);
+		zipInfo.add(1, dir);
+
+		RemoteRequest request = new RemoteRequest();
+		request.set("sendFile", "getAPK", zipInfo);
+
+
+		ArrayList<AppendingObjectOutputStream> output_list = RemoteService.resourceToOutput
+				.get(Device.RESOURCE_TYPE_REMOTE_ACTIVITY);
+		AppendingObjectOutputStream output = output_list.get(deviceNum);
+
+	}
+
+}
